package me.Demon.DemonMmKillsDrop;

import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.List;

public abstract class KillDropAPI {

    public static ItemStack getItems(String key, int amount){
        ItemStack item = new ItemStack(Material.DIAMOND,64);
        if (Main.ItemsListID.contains(key)) {
            item = Main.plugin.getConfig().getItemStack("ItemsData."+key).clone();
            item.setAmount(amount);
            ItemMeta meta = item.getItemMeta();
            List<String> lore = meta.getLore();
            meta.setLore(lore);
            item.setItemMeta(meta);
        }
        return item;
    }

    //获取今日掉落物数量
    public static int getDayAmount(String key){
        int time = Integer.parseInt(Main.getTime("dd"));
        return Main.dropLogG.getInt("DropItems."+time+"."+key);
    }

    //增加今日掉落物数量
    public static void addDayAmount(String key,int amount){
        int time = Integer.parseInt(Main.getTime("dd"));
        Main.dropLogG.set("DropItems."+time+"."+key,(getDayAmount(key)+amount));
        Main.saveDropLogConfig();
    }

    public static ItemStack getItemData(String key){
        ItemStack item = new ItemStack(Material.STONE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§c§l掉落物错误X");
        item.setItemMeta(meta);
        FileConfiguration yml = Main.plugin.getConfig();
        if(yml.getString("ItemsData."+key) != null){
            item = yml.getItemStack("ItemsData."+key).clone();
        }
        return item;
    }

}
