package me.Demon.DemonMmKillsDrop;

import me.Demon.DemonMmKillsDrop.listener.ItemBaoHu;
import me.Demon.DemonMmKillsDrop.listener.KillMobsDrop;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

public class Main extends JavaPlugin implements Listener {

    public static Main plugin;
    public static double drop_double = 1.0;
    public static HashMap<String,MobsPer> pps = new HashMap<>();
    public static HashMap<String,StatsPer> statsMap = new HashMap<>();
    public static List<String> ItemsListID = new ArrayList<>();
    public static File Datafile = new File("plugins/DemonMmKillsDrop", "MobsData.yml");
    public static FileConfiguration DataG = YamlConfiguration.loadConfiguration(Datafile);
    public static void saveDataConfig(){ try { DataG.save(Datafile); } catch (IOException e) { e.printStackTrace(); } }
    public static File DropLogfile = new File("plugins/DemonMmKillsDrop", "DropItemLog.yml");
    public static FileConfiguration dropLogG = YamlConfiguration.loadConfiguration(DropLogfile);
    public static void saveDropLogConfig(){ try { dropLogG.save(DropLogfile); } catch (IOException e) { e.printStackTrace(); } }

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        if(isRefreshUpdata()){
            dropLogG.set("Todaytime",getTime("yyyy/MM/dd"));
            int time = Integer.parseInt(getTime("dd"));
            Main.dropLogG.set("DropItems."+time,null);
            Main.saveDropLogConfig();
            Bukkit.getConsoleSender().sendMessage("§d[KillMobDrop] §6已清理今日所有掉落数据~");
        }
        Bukkit.getConsoleSender().sendMessage("§b[KillMobDrop] §a插件成功载入Server！");
        Bukkit.getConsoleSender().sendMessage("§b[KillMobDrop] §a妖魂QQ:1763917516");
        getServer().getPluginManager().registerEvents(this, this);
        Bukkit.getPluginManager().registerEvents(new KillMobsDrop(),this);
        Bukkit.getPluginManager().registerEvents(new ItemBaoHu(),this);
        if(getConfig().getString("ItemsData") != null) {
            ItemsListID.addAll(getConfig().getConfigurationSection("ItemsData").getKeys(false));
        }
        for (String WorldName : getConfig().getConfigurationSection("MobsDrop").getKeys(false)){
            int amount = 0;
            for (String Mob_key : getConfig().getConfigurationSection("MobsDrop."+WorldName).getKeys(false)){
                Main.pps.put(Mob_key, new MobsPer(Mob_key));
                amount++;
            }
            Bukkit.getConsoleSender().sendMessage("§a- 世界: "+WorldName+"  导入: "+amount+"个怪物");
        }
    }
    public void onDisable() {
        for (String WorldName : getConfig().getConfigurationSection("MobsDrop").getKeys(false)){
            int amount = 0;
            for (String Mob_key : getConfig().getConfigurationSection("MobsDrop."+WorldName).getKeys(false)) {
                if (Main.pps.get(Mob_key) != null) {
                    Main.pps.get(Mob_key).savePlayerData();
                    amount++;
                }
            }
            Bukkit.getConsoleSender().sendMessage("§a- 世界: "+WorldName+"  已保存: "+amount+"个怪物死亡数据");
        }
        Bukkit.getConsoleSender().sendMessage("§b[KillMobDrop] §c插件已正常关闭！");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("dmmdrop") && sender.isOp()) {
            if(args.length == 0){
                sender.sendMessage("");
                sender.sendMessage("§e------- ======= §6偙国掉落物 §e======= -------");
                sender.sendMessage("§2/dmmdrop open §f- §2打开掉落物仓库");
                sender.sendMessage("§2/dmmdrop stats §f- §2查看材料掉落统计");
                sender.sendMessage("§2/dmmdrop clear §f- §2清理材料掉落统计");
                sender.sendMessage("§2/dmmdrop statshh §f- §2查看灵环掉落统计");
                sender.sendMessage("§2/dmmdrop dropzf §e[倍率] §f- §2设置掉落物倍率");
                sender.sendMessage("§2/dmmdrop give §e[物品] §2<数量> {玩家} §f- §2给予玩家物品");
                sender.sendMessage("§e------- ======= §6偙国掉落物 §e======= -------");
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("save")){
                for (String WorldName : getConfig().getConfigurationSection("MobsDrop").getKeys(false)) {
                    for (String Mob_key : getConfig().getConfigurationSection("MobsDrop." + WorldName).getKeys(false)) {
                        if (Main.pps.get(Mob_key) != null) {
                            Main.pps.get(Mob_key).savePlayerData();
                        }
                    }
                }
                sender.sendMessage("§7[§c消息§7] §a成功手动保存数据.");
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("clear")){
                FileConfiguration yml = Main.dropLogG;
                yml.set("DropItems",null);
                Main.saveDropLogConfig();
                sender.sendMessage("§7[§c消息§7] §a成功清理历史掉落数据。");
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("dropzf")){
                drop_double = Double.parseDouble(args[1]);
                sender.sendMessage("§7[§c消息§7] §a当前服务器掉落率增幅为: §e"+((drop_double-1)*100)+"%");
            }
            //dmmdrop give [key] [amount] <player>
            if(args.length == 4 && args[0].equalsIgnoreCase("give")){
                if (ItemsListID.contains(args[1])) {
                    ItemStack item = getConfig().getItemStack("ItemsData."+args[1]).clone();
                    int amount;
                    try {
                        amount = Integer.parseInt(args[2]);
                    } catch (Exception e) {
                        sender.sendMessage("§7[§6掉落库§7] §c数量参数必须是整数");
                        return true;
                    }
                    Player player = Bukkit.getPlayer(args[3]);
                    if (player == null) {
                        sender.sendMessage("§7[§6掉落库§7] §c目标玩家不在线无法给予");
                        return true;
                    }
                    item.setAmount(amount);
                    player.getInventory().addItem(item);
                    sender.sendMessage("§7[§6掉落库§7] §f成功给予玩家"+ player.getName()+" "+args[1]+" "+amount+"个");
                }else{
                    sender.sendMessage("§7[§6掉落库§7] §c物品不存在.");
                }
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("open")){
                OpenItemsGui((Player) sender);
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("stats")){
                FileConfiguration yml = Main.dropLogG;
                List<String> keyId_List = new ArrayList<>();
                int day = 0;
                if(yml.getConfigurationSection("DropItems") != null) {
                    for (String time : yml.getConfigurationSection("DropItems").getKeys(false)) {
                        if (yml.getConfigurationSection("DropItems." + time) != null) {
                            for (String keyId : yml.getConfigurationSection("DropItems." + time).getKeys(false)) {
                                if (!keyId_List.contains(keyId)) {
                                    keyId_List.add(keyId);
                                }
                                int amount = yml.getInt("DropItems." + time + "." + keyId);
                                if (Main.statsMap.get(keyId) == null) {
                                    Main.statsMap.put(keyId, new StatsPer(keyId));
                                }
                                Main.statsMap.get(keyId).addAmount(amount);
                            }
                        }
                        day++;
                    }
                    sender.sendMessage("§a战争领域§e[" + day + "天]§a内的掉落物数据统计: ");
                    for (int i = 0; i < keyId_List.size(); i++) {
                        String keyId = keyId_List.get(i);
                        int amount = Main.statsMap.get(keyId).getAmount();
                        sender.sendMessage("§7[§b" + keyId + "§7] §f§l- §a" + amount + "个");
                    }
                    sender.sendMessage("§f[§c消息§f] §a目前服务器掉落物总计: §e" + keyId_List.size() + "样");
                    Main.statsMap.clear();
                }
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("reload")){
                reloadConfig();
                Main.pps.clear();
                for (String WorldName : getConfig().getConfigurationSection("MobsDrop").getKeys(false)){
                    int amount = 0;
                    for (String Mob_key : getConfig().getConfigurationSection("MobsDrop."+WorldName).getKeys(false)){
                        Main.pps.put(Mob_key, new MobsPer(Mob_key));
                        amount++;
                    }
                    sender.sendMessage("§a- 世界: "+WorldName+"  导入: "+amount+"个怪物");
                }
                sender.sendMessage("§7[§c消息§7] §a重载配置完成.");
            }
        }
        return true;
    }
    public static int getRandomInt(int max, int min) {
        return (int) (Math.random() * (max - min + 1) + min);
    }
    public static boolean itemIsNull(ItemStack item){
        return item == null || item.getType() == Material.AIR;
    }
    public static boolean itemIsLore(ItemStack item){ return item.getItemMeta().getLore()==null; }
    public static String getTime(String Format){
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(Format);
        return datatime.format(date);
    }


    public void OpenItemsGui(Player p){
        Inventory inv = Bukkit.createInventory(null,54,"§i§r§m§i§r掉落物集成库");
        for (String key : getConfig().getConfigurationSection("ItemsData").getKeys(false)) {
            ItemStack item = getConfig().getItemStack("ItemsData." + key).clone();
            item.setAmount(1);
            inv.addItem(item);
        }
        p.openInventory(inv);
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1,2);
    }

    @EventHandler
    public void onclick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        if(e.getInventory() != null && "§i§r§m§i§r掉落物集成库".equalsIgnoreCase(e.getInventory().getTitle())){
            e.setCancelled(true);
            if(e.getRawSlot() >= 0 && e.getRawSlot() < 54){
                ItemStack item = e.getCurrentItem();
                if(!itemIsNull(item)) {
                    if(e.getClick() == ClickType.LEFT) {
                        item.setAmount(1);
                        p.getInventory().addItem(item);
                    }else if(e.getClick() == ClickType.RIGHT){
                        item.setAmount(10);
                        p.getInventory().addItem(item);
                    }else if(e.getClick() == ClickType.MIDDLE){
                        item.setAmount(64);
                        p.getInventory().addItem(item);
                    }
                    p.playSound(p.getLocation(), Sound.ENTITY_CHICKEN_EGG,1,2);
                }
            }
        }
    }

    //獲取上次每周數據刷新的時間 年/月/日
    public static String getTodaytime() {
        FileConfiguration yml = Main.dropLogG;
        if(yml.getString("Todaytime") != null){
            return yml.getString("Todaytime");
        }
        return "2023/06/24";
    }

    //判斷是否今天是數據刷新的壹天
    public static boolean isRefreshUpdata() {
        if(!getTodaytime().equalsIgnoreCase(getTime("yyyy/MM/dd"))) {
            return true;
        }
        return false;
    }
}
