package me.Demon.DemonMmKillsDrop.Event;

import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class KillsMobsDropEvent extends Event {

    private static HandlerList handlers = new HandlerList();
    private Player player;
    private String item_type;
    private int item_amount;

    @Override
    public HandlerList getHandlers(){
        return handlers;
    }

    public static HandlerList getHandlerList(){
        return handlers;
    }

    public KillsMobsDropEvent(Player player, String item_type, int item_amount){
        this.player = player;
        this.item_type = item_type;
        this.item_amount = item_amount;
    }

    public Player getPlayer(){
        return player;
    }

    public String getItem_type(){
        return item_type;
    }

    public int getItem_amount() {
        return item_amount;
    }
}
