package me.Demon.DemonMmKillsDrop.listener;

import io.lumine.xikage.mythicmobs.MythicMobs;
import me.Demon.DemonMmKillsDrop.manager.DamageManager;
import org.bukkit.Location;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.plugin.Plugin;
import org.bukkit.util.Vector;

import java.util.*;

public class ItemBaoHu implements Listener {

    @EventHandler
    public void onEntityPickupItem(PlayerPickupItemEvent event) {
        Player player = event.getPlayer();
        Item item = event.getItem();
        if (item.hasMetadata("owner") && item.hasMetadata("time")) {
            String u = null;
            long time = 0L;
            for (MetadataValue metadataValue : item.getMetadata("owner")) {
                u = metadataValue.asString();
            }
            for (MetadataValue metadataValue : item.getMetadata("time")) {
                time = metadataValue.asLong();
            }
            if (u == null || time == 0) {
                return;
            }
            UUID uuid = UUID.fromString(u);
            if (time + (1000L * 10) > System.currentTimeMillis()) {
                if (!player.getUniqueId().equals(uuid)) {
                    Vector v = player.getLocation().toVector().subtract(item.getLocation().toVector()).normalize().multiply(1).setY(0.1);
                    player.setVelocity(v);
                    player.sendMessage("§7[§6掉落保护§7] §f你无法拾取此物品!!");
                    event.setCancelled(true);
                }
            }
        }
    }


    @EventHandler(ignoreCancelled = true, priority = EventPriority.MONITOR)
    public void onDamage(EntityDamageByEntityEvent event) {
        Entity damager = event.getDamager();
        if (!(damager instanceof Player)) {
            return;
        }
        Entity entity = event.getEntity();
        if (!MythicMobs.inst().getAPIHelper().isMythicMob(entity) || !(entity instanceof LivingEntity)) {
            return;
        }
        LivingEntity livingEntity = (LivingEntity) entity;
        double damage = event.getDamage();
        if (damage > livingEntity.getHealth()) {
            damage = livingEntity.getHealth();
        }
        DamageManager.damage(damager.getUniqueId(), entity.getUniqueId(), damage);
    }

}
