package me.Demon.DemonMmKillsDrop.listener;

import io.lumine.xikage.mythicmobs.adapters.bukkit.BukkitAdapter;
import io.lumine.xikage.mythicmobs.api.bukkit.events.MythicMobDeathEvent;
import me.Demon.DemonMmKillsDrop.Event.KillsMobsDropEvent;
import me.Demon.DemonMmKillsDrop.KillDropAPI;
import me.Demon.DemonMmKillsDrop.Main;
import me.Demon.DemonMmKillsDrop.manager.DamageManager;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.util.Vector;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;

public class KillMobsDrop implements Listener {

    @EventHandler
    public void onkills(MythicMobDeathEvent e) {
        if (e.getKiller() instanceof Player) {
            Player p = (Player) e.getKiller();
            if (e.getEntity().getCustomName() != null) {
                //获取玩家所在世界名
                String worldName = p.getWorld().getName();
                //获取怪物的MM代号
                String mobsKey = e.getMob().getType().getInternalName();
                if (Main.pps.get(mobsKey) != null) {
                    Main.pps.get(mobsKey).addKillAmount(1);
                    //获取这只魂兽当前被击杀次数
                    int amount = Main.pps.get(mobsKey).getKillAmount();
                    int fujia_gailv = 0;
                    if (amount >= 20) {
                        fujia_gailv = amount;
                    }
                    boolean isdrop = false;
                    List<ItemStack> itemStacks = new ArrayList<>();
                    FileConfiguration yml = Main.plugin.getConfig();
                    for (String DropKey : yml.getConfigurationSection("MobsDrop." + worldName + "." + mobsKey).getKeys(false)) {
                        int gailv = yml.getInt("MobsDrop." + worldName + "." + mobsKey + "." + DropKey);
                        double newgailv = (gailv * 0.7) * Main.drop_double;
                        if (p.hasPermission("vip2.use")) {
                            newgailv = (gailv * 0.85) * Main.drop_double;
                        }
                        int random = Main.getRandomInt(1000, 1);
                        double addDrop = 1.0;
                        if (random <= ((newgailv + fujia_gailv) * addDrop)) {
                            isdrop = true;
                            if (DropKey.contains("#")) {
                                String ItemsKey = DropKey.split("#")[0];
                                ItemStack dropItem = KillDropAPI.getItemData(ItemsKey);
                                int max = Integer.parseInt(DropKey.split("#")[1]);
                                int d_amount = Main.getRandomInt(max, 1);
                                dropItem.setAmount(d_amount);
                                itemStacks.add(dropItem);
                                // 事件
                                KillDropAPI.addDayAmount(ItemsKey, d_amount);
                                KillsMobsDropEvent event = new KillsMobsDropEvent(p, ItemsKey, d_amount);
                                Bukkit.getPluginManager().callEvent(event);
                            } else {
                                // 将东西发送至队长背包
                                ItemStack dropItem = KillDropAPI.getItemData(DropKey);
                                itemStacks.add(dropItem);
                                // 事件
                                KillDropAPI.addDayAmount(DropKey, 1);
                                KillsMobsDropEvent event = new KillsMobsDropEvent(p, DropKey, 1);
                                Bukkit.getPluginManager().callEvent(event);
                            }
                        }
                    }
                    if (isdrop) {
                        if (p.hasPermission("vip2.use")) {
                            DemonAPI.sendActionBar(p, "§6§l§k|||§r §b！副本爆率增幅生效中！ §6§l§k|||§r");
                        }
                        Main.pps.get(mobsKey).setKillAmount(0);
                        UUID entityUUID = e.getMob().getUniqueId();
                        Map<UUID, Double> map = DamageManager.getEntityDamageMap(entityUUID);
                        List<Map.Entry<UUID, Double>> list = getEntries(map);
                        Location location = BukkitAdapter.adapt(e.getMob().getLocation());
                        if (!list.isEmpty()) {
                            UUID one = list.get(0).getKey();
                            itemStacks.forEach(i -> {
                                Item item = location.getWorld().dropItem(location, i);
                                item.setPickupDelay(0);
                                item.setMetadata("owner", new FixedMetadataValue(Main.plugin, one.toString()));
                                item.setMetadata("time", new FixedMetadataValue(Main.plugin, System.currentTimeMillis()));
                                item.setVelocity(new Vector(getRandomDouble(0.5), getRandomDouble(0.1), getRandomDouble(0.5)));
                            });
                        }
                    }
                }
            }
        }
    }

    private static List<Map.Entry<UUID, Double>> getEntries(Map<UUID, Double> map) {
        List<Map.Entry<UUID, Double>> list = new ArrayList<>(map.entrySet());
        list.sort((arg0, arg1) -> {
            if (arg0.getValue() > arg1.getValue()) {
                return -1;
            } else {
                return 1;
            }
        });
        return list;
    }


    private double getRandomDouble(double max) {
        int pow = (int) Math.pow(10, 2);
        return Math.floor((Math.random() * (max - 0.01) + 0.01) * pow) / pow;
    }
}
